/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */
 
var interval;

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
    version.innerText += " " + widget.system("defaults read ~/Library/Widgets/BatteryLevel.wdgt/Info CFBundleVersion", null).outputString;
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
    interval.clear();
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
   interval = setInterval("ioreg()", 2000);
   ioreg();
}

function ioreg() {
    widget.system("/usr/sbin/ioreg -l -d 12 | grep -E '(\"BatteryPercent\"|\"IOClass\" = \"IOAppleBluetoothHIDDriver\"|\"IOClass\" = \"AppleBluetoothHIDKeyboard\"|\"IOClass\" = \"BNBMouseDevice\"|\"IOClass\" = \"BNBTrackpadDevice\")'", update);
}

function update(output) {
    var str = output.outputString;

    str = str.replace(/\||\"/g, "");
    str = str.replace(/^ */mg, "");
    str = str.replace(/.*ExtendedFeatures.*|\|/g, "");
    
    var percent = str.match(/\d+/g);
    
    if (str.search("IOAppleBluetoothHIDDriver") != -1) {
        text1.style.color = "#f0f0f0";
        try {
            lvl = str.match(/BatteryPercent = (\d+)\nIOClass = IOAppleBluetoothHIDDriver/)[1];
            document.getElementById("indicator1").object.setValue((lvl-100)*-1);
            percent1.innerText = lvl + "%";
            image1.style.visibility = "hidden";
        }
        catch(err) {
            image1.style.visibility = "visible";
        }
    }
    else if (str.search("AppleBluetoothHIDKeyboard") != -1) {
        text1.style.color = "#f0f0f0";
        try {
            lvl = str.match(/BatteryPercent = (\d+)\nIOClass = AppleBluetoothHIDKeyboard/)[1];
            document.getElementById("indicator1").object.setValue((lvl-100)*-1);
            percent1.innerText = lvl + "%";
            image1.style.visibility = "hidden";
        }
        catch(err) {
            image1.style.visibility = "visible";
        }
    }
    else {
        document.getElementById("indicator1").object.setValue(-1);
        percent1.innerText = "";
        text1.style.color = "#777";
    }
    
    if (str.search("BNBMouseDevice") != -1) {
        text2.style.color = "#f0f0f0";
        try {
            lvl = str.match(/BatteryPercent = (\d+)\nIOClass = BNBMouseDevice/)[1];
            document.getElementById("indicator2").object.setValue((lvl-100)*-1);
            percent2.innerText = lvl + "%";
            image2.style.visibility = "hidden";
        }
        catch(err) {
            image2.style.visibility = "visible";
        }
    }
    else {
        document.getElementById("indicator2").object.setValue(-1);
        percent2.innerText = "";
        text2.style.color = "#777";
    }
    
    if (str.search("BNBTrackpadDevice") != -1) {
        text3.style.color = "#f0f0f0";
        try {
            lvl = str.match(/BatteryPercent = (\d+)\nIOClass = BNBTrackpadDevice/)[1];
            document.getElementById("indicator3").object.setValue((lvl-100)*-1);
            percent3.innerText = lvl + "%";
            image3.style.visibility = "hidden";
        }
        catch(err) {
            image3.style.visibility = "visible";
        }
    }
    else {
        document.getElementById("indicator3").object.setValue(-1);
        percent3.innerText = "";
        text3.style.color = "#777";
    }
    
    /*
    //DEBUG
    percent1.innerText = "13";
    percent2.innerText = "42";
    percent3.innerText = "7";
    document.getElementById("indicator1").object.setValue(85);
    document.getElementById("indicator2").object.setValue(50);
    document.getElementById("indicator3").object.setValue(95);
    percent1.innerText = "100%";
    percent2.innerText = "100%";
    percent3.innerText = "100%";
    */
    
}

function showWebsite(event) {
    widget.openURL("http://markusweimar.de/software_en/batterylevel");
}


function reload(event) {
    show();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}
